#pragma once on
//Bookmarker by Seth R. Flaxman last changed 3-28-98 created sometime 1-98
//this whole program relies on netpositive settings
//being in /boot/home/config/settings/NetPositive
//That is something one should never rely on!!!!!!!!!!!!!!!
#include "marker.h"

//customizable stuff
//change these HTML tags and english prompts to
//whatever you want
//if you want a custom version of Bookmarker great!
//if you want to translate it please send me the translated
//stuff in e-mail to seth@abisoft.com
const char beginwrapper[] = "<HTML>\n<HEAD><TITLE>Bookmarks</TITLE></HEAD>\n"
	"<BODY BGCOLOR=\"#ffffff\">\n<TABLE>\n<TR>\n<TD>"
	"<BR>\n<BR>\n<H1>Bookmarks for NetPositive 1.0</H1>\n"
	"<HR></TD></tr></TABLE>";
const char gowrapperstart[] = "<HTML>  <HEAD>  <META HTTP-EQUIV=\"Refresh\" CONTENT= \"1; URL=";
const char gowrapperend[] = "\"></META></HTML>";
const char endwrapper[] = "<p><hr>\nThis page was made by Bookmarker.\n"
	"<p>Bookmarker was made by Seth R. Flaxman.<p>Go to\n" 
	"the Bookmarker\n"
	"<a href=\"http://www.abisoft.com/Bookmarker/\">home page</a>\n"
	"to learn more.\n</body>\n</html>"; 

const char bookmarkfile[] = "/boot/home/config/settings/NetPositive/Bookmarks/Bookmarks.html";
const char bookmarkdir[] = "/boot/home/config/settings/NetPositive/Bookmarks";
const char bookmarkdirhtml[] = "file:/boot/home/config/settings/NetPositive/Bookmarks";
const char bookmarkolddir[] = "file:/boot/home/config/settings/NetPositive/Bookmarks/Old";
const char startupfile[] = "file:/boot/home/config/settings/NetPositive/Bookmarks/Startup.html";
const char bookmarktitle[] = "HTML Bookmarks";
const char bookmarkfilelinkname[] = "Bookmarker bookmarks"; //this way it appears first alphabetically
const char bookmarkfilehtml[] = "file:///boot/home/config/settings/NetPositive/Bookmarks/Bookmarks.html";
const char helpmessage[] = "Bookmarker:\n\t\t-r        restore old bookmarks\n\t\t-?        print this message\n"
	"\t\t-version  print version\n\t\tno args   make or update bookmark file";
const char version[] = "Bookmarker v0.96 for x86 and Intel";
const char hideprompt[] = "Hide old bookmarks?";
const char outputprompt[] = "Which method should Bookmarker use for your Bookmarks?";
const char hidemessage[] = "Hiding old bookmarks. Choose restore to restore old bookmarks\n\n";
const char hiddenmessage[] = "Here is the real hidden feature:\n"
	"Choose 2 at the Should Bookmarker... prompt, now,\n"
	"open one of the NetPositive Bookmarks in your\n"
	"favorite text editor (should be vi or vim!).\n"
	"To do this, open a terminal and cd to\n"
	"/boot/home/config/settings/NetPositive/Bookmarks/\n"
	"if you chose y at the hide bookmarks prompts cd into\n"
	"/boot/home/config/settings/NetPositive/Bookmarks/Old and type vi *\n"
	"I bet you didn't know NetPositive supported that weird Refresh tag!\n";
const char sig[] = "application/x-vnd-abisoft-Bookmarker";
const char fontcolor[] = "#0000FF";

const char urlAttrName[] = "META:url";

const char choicetext[] = "Welcome to Bookmarker 0.95!\nWould you like to:\n";
const char choicebutton1[] = "Quit";
const char choicebutton2[] = "Restore old bookmarks";
const char choicebutton3[] = "Update Bookmarkfile";
//other customizable stuff
//If you want Bookmarker to work as fast a possible uncomment
//the next line and Bookmark will be fasterer! ;)
//#define FASTERER

int main(int argc, char *argv[])
{
	BookmarkerApp app(sig, argc, argv);
}
BookmarkerApp::BookmarkerApp(const char *signature, int argc, char *argv[]) : 
	BApplication(signature)
{	
	BAlert *choiceAlert = new BAlert("", choicetext, choicebutton1, choicebutton2, choicebutton3, B_WIDTH_FROM_LABEL);
	int32 which = choiceAlert->Go();
	if(which == 1) {
		Restore(); 
	}
	else if(which == 0) 
		exit(0);
	if(argc > 1) {
		if(strcmp(argv[1], "-seth") == 0) //HERE IS HOW TO GET THE HIDDEN MESSAGE
			printf("%s\n", hiddenmessage); //YOU CHEATER!
	}
	BDirectory *bDir = new BDirectory(bookmarkdir);
	bool error;
	bDir->SetTo(bookmarkdir);
	BFile file, html, bookmark;
	bDir->CreateFile(bookmarkfile, &html);
	bDir->CreateFile(bookmarkfilelinkname, &bookmark);
	bookmark.WriteAttr(urlAttrName, B_STRING_TYPE, 0, bookmarkfilehtml, strlen(bookmarkfilehtml));
	//bookmark.WriteAttr("title", B_STRING_TYPE, 0, bookmarktitle, strlen(bookmarktitle));
	bookmark.WriteAttr("not bookmark", B_BOOL_TYPE, 0, &error, sizeof(bool));
	//write the html required
	html.Write(beginwrapper, strlen(beginwrapper));
	entry_ref ref;
	char url[2048];
	char *urlsave; 
	char writeText[5000];
	attr_info ai;
	bool trash = false;
	BPath path;
	BEntry entry;
	BDirectory trashDir;
	html.WriteAttr("not bookmark", B_BOOL_TYPE, 0, &error, sizeof(bool));
	
	if(bDir->CreateDirectory("Old", &trashDir) != B_OK) {
		char oldDir[1024];
		sprintf(oldDir, "%s/Old", bookmarkdir);
		trashDir.SetTo(oldDir);
	}
	int32 numOfRefs = 0;
	BAlert *alert = new BAlert("", "Creating Bookmarks!", "Okay");
	alert->Lock();
	alert->ButtonAt(0)->SetEnabled(false);
	alert->Unlock();
	alert->Go(NULL);
	BNodeInfo ni;
	while(trashDir.GetNextRef(&ref) == B_OK) {
		error = false;
		file.SetTo(&ref, B_READ_WRITE);
		error = file.GetAttrInfo(urlAttrName, &ai);
		file.ReadAttr(urlAttrName, ai.type, 0, url, ai.size);
		url[ai.size] = '\0';
		printf("url = %s\n", url);
		urlsave = strdup(url);
	//	file.GetAttrInfo("title", &ai);
//		file.ReadAttr("title", ai.type, 0, title, ai.size);
//		title[ai.size] = '\0';
		sprintf(writeText, "<p><font color=\"%s\"><a href=\"%s\">%s</a></font>\n", fontcolor, urlsave, ref.name); 
		if(file.GetAttrInfo("not bookmark", &ai) != B_OK && error == B_OK) {
			html.Write(writeText, strlen(writeText));
			sprintf(writeText, "%s%s%s\n", gowrapperstart, urlsave, gowrapperend);
			file.Write(writeText, strlen(writeText));
		}
		ni.SetTo(&file);
		ni.SetType("application/x-vnd.Be-BOOK");
		ni.SetPreferredApp("application/x-vnd.Be-NPOS");
	}
	while(bDir->GetNextRef(&ref) == B_OK) {
		error = false;
		file.SetTo(&ref, B_READ_WRITE);
		error = file.GetAttrInfo(urlAttrName, &ai);
		file.ReadAttr(urlAttrName, ai.type, 0, url, ai.size);
		url[ai.size] = '\0';
		printf("url = %s\n", url);
		urlsave = strdup(url);
		//file.GetAttrInfo("title", &ai);
		//file.ReadAttr("title", ai.type, 0, title, ai.size);
		//title[ai.size] = '\0';
		sprintf(writeText, "<p><a href=\"%s\">%s</a>\n", urlsave, ref.name); 
		if(file.GetAttrInfo("not bookmark", &ai) != B_OK && error == B_OK) {
			html.Write(writeText, strlen(writeText));
			sprintf(writeText, "%s%s%s\n", gowrapperstart, urlsave, gowrapperend);
			file.Write(writeText, strlen(writeText));
			numOfRefs++;
			if(numOfRefs == 1) {
			
				BAlert *balert = new BAlert("", hideprompt, "No", "Yes");
				int32 choice = balert->Go();
				if(choice == 1)  {
					trash = true;
					alert->Lock();
					alert->TextView()->SetText(hidemessage);
					alert->Unlock();		
				}
			}	
			if(trash == true) {
				entry.SetTo(&ref);
				entry.MoveTo(&trashDir, NULL, true);
			}
		}
		ni.SetTo(&file);
		ni.SetType("application/x-vnd.Be-BOOK");
		ni.SetPreferredApp("application/x-vnd.Be-NPOS");
	}
#ifndef FASTERER
	snooze(1000.0 * 1000.0);
#endif
	alert->Lock();
	alert->ButtonAt(0)->SetEnabled(true);
	alert->TextView()->SetText("Done creating bookmarks!\n");
	alert->Unlock();
	html.Write(endwrapper, strlen(endwrapper));
	BAlert *done = new BAlert("", outputprompt, "Experimental", "Stupid Conventional", "Startup file", 
		B_WIDTH_FROM_LABEL);
	int32 choice = done->Go();
	if(choice == 0) {  //use experimental method
		if(trash == true || numOfRefs == 0)
			strcpy(url, bookmarkolddir);
		else 
			strcpy(url, bookmarkdirhtml);
	}	
	else if(choice == 1) { //stupid method
		strcpy(url, bookmarkfilehtml);
	}
	else { //cool method
		BFile start;
		if(start.SetTo(bDir, "Startup.html", B_READ_WRITE) != B_OK) {
			bDir->CreateFile("Startup.html", &start);
		}
		BDirectory app;
		app_info ai;
		GetAppInfo(&ai);
		app.SetTo(&ai.ref);
		BEntry entry(&ai.ref);
		BPath path;
		entry.GetPath(&path);
		BPath parentPath;
		path.GetParent(&parentPath);
		char pathBuf[B_FILE_NAME_LENGTH+1];
		sprintf(pathBuf, "%s/images/Bookmarker.gif", parentPath.Path());
			printf("gifChar = %s\n", parentPath.Path());
		if(entry.SetTo(pathBuf) == B_OK) {
			BFile gif;
			gif.SetTo(&entry, B_READ_ONLY);
			BFile move;
			bDir->CreateFile("Bookmarker.gif", &move);
			off_t size;
			if(bDir->CreateFile("Bookmarker.gif", &move) == B_OK) {
				gif.GetSize(&size);
				char *gifChar = new char[size];
				gif.Read(gifChar, size);
				move.Write(gifChar, size);
			}
			parentPath.Append("StartupPage.html");
			gif.SetTo(parentPath.Path(), B_READ_WRITE);
			gif.GetSize(&size);
			char *gifChar = new char[size];
			gif.Read(gifChar, size);
			start.Write(gifChar, strlen(gifChar));
		}
		strcpy(url, startupfile);
		BFile settings;
		settings.SetTo("/boot/home/config/settings/NetPositive/settings", B_READ_WRITE); //bad
		char *settingsBuf;
		off_t size;
		settings.GetSize(&size);
		settingsBuf = new char[size+strlen(startupfile)];
		settings.Read(settingsBuf, size);
		int32 i = 0;
		char *beginBuf, *endBuf;
		while(settingsBuf[i] != '\n') { //the one we want to change is on the second line
			i++;
		}
		settingsBuf[i] = '\0';
		beginBuf = new char[i+1];
		sprintf(beginBuf, "%s\n", settingsBuf);
		i++;
		int32 startChangeLine = i;
		while(settingsBuf[i] != '\n') {
			i++;
		}
		i++;
		endBuf = new char[size-i];
		sprintf(endBuf, "%s", &settingsBuf[i]);
		sprintf(settingsBuf, "%s%s\n%s", beginBuf, startupfile, endBuf);
		settings.Seek(0, SEEK_SET);
		settings.Write(settingsBuf, strlen(settingsBuf));
	}
	//the following code is very easy to copy and use
	//it launchs NetPositive
	BMessage msg(B_ARGV_RECEIVED);
	msg.AddString("argv", "NetPositive");
	msg.AddString("argv", url); //If you want to use this code change url
	msg.AddInt32("argc", 2);                 //to your website or docs or whatever
	BMessenger messenger("application/x-vnd.Be-NPOS", -1, NULL); //this tries to open a BMessenger to 
	if (messenger.IsValid())                                     //Net+ if valid it sends a BMessage
  		messenger.SendMessage( &msg );
 	else                                                         //otherwise Net+ is not running so 
  		be_roster->Launch("application/x-vnd.Be-NPOS", &msg);    //it launches it 
	
}
void BookmarkerApp::MessageReceived(BMessage *msg)
{
	switch(msg->what) {
		case RESTORE_DONE:
			PostMessage(B_QUIT_REQUESTED);
			
			break;
		default:
			BApplication::MessageReceived(msg);
			break;
	}
}
void BookmarkerApp::Restore()
{
	BAlert *restore = new BAlert("", "Restoring old bookmarks\n", "Okay");
	restore->Lock();
	restore->ButtonAt(0)->SetEnabled(false);
	restore->Unlock();
	restore->Go(NULL);
	char old[1024];
	sprintf(old, "%s/Old", bookmarkdir);
	BDirectory bDir;
	bDir.SetTo(old);
	entry_ref ref;
	BEntry entry;
	BDirectory trash;
	BPath path;
	trash.SetTo(bookmarkdir);
	while(bDir.GetNextRef(&ref) == B_OK) { 
		entry.SetTo(&ref);
		entry.MoveTo(&trash);
	}
	find_directory(B_TRASH_DIRECTORY, &path);
	trash.SetTo(path.Path());
	bDir.SetTo(bookmarkdir);
	entry.SetTo(&bDir, "Bookmarks");
	entry.MoveTo(&trash, NULL, true);
	entry.SetTo(&bDir, "Bookmarks.html");
	entry.MoveTo(&trash, NULL, true);
	
#ifndef FASTERER
	snooze(1000.0 * 1000.0);
#endif
	restore->Lock();
	restore->TextView()->SetText("Done restoring bookmarks\n");
	restore->Unlock();
#ifndef FASTERER
	snooze(1000.0 * 1000.0);
#endif
	restore->PostMessage(B_QUIT_REQUESTED);
	exit(0);
}